package com.crm.rely.backend.util;

import java.io.IOException;

/**
 * 计算坐标之间的距离
 *
 * @program: user-custom
 * @description:
 * @author: houn
 * @create: 2019-05-30 16:27
 */
public class DistanceUtil {
    private static double EARTH_RADIUS = 6371.393;

    /**
     * 计算两个经纬度之间的距离
     *
     * @param lat1
     * @param lng1
     * @param lat2
     * @param lng2
     * @return
     */
    public static double getDistance(double lat1, double lng1, double lat2, double lng2) {
        double radLat1 = rad(lat1);
        double radLat2 = rad(lat2);
        double a = radLat1 - radLat2;
        double b = rad(lng1) - rad(lng2);
        double s = 2 * Math.asin(Math.sqrt(Math.pow(Math.sin(a / 2), 2) +
                Math.cos(radLat1) * Math.cos(radLat2) * Math.pow(Math.sin(b / 2), 2)));
        s = s * EARTH_RADIUS;
        s = Math.round(s * 1000);
        return s;
    }

    private static double rad(double d) {
        return d * Math.PI / 180.0;
    }

    public static void main(String[] args) throws IOException {

        double distance = getDistance(30.2047700000, 120.2169740000, 30.2056210000, 120.2232890000);

        System.out.println(distance);
    }
}

